/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm-pdu-descriptions */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Tue Jun 28 12:09:14 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -per -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6535gen/LibItsDenm_asn1.gen DENM-PDU-Descriptions.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1;

import com.oss.asn1.*;
import com.oss.metadata.*;

public class Libitsdenm_asn1 extends ASN1Project {

    /**
     * Initialize the pdu decoder.
     */
    private static final ProjectInfo c_projectInfo = new ProjectInfo (
	new PDUDecoder (
	    new PDUDecoderElement[] {
		new PDUDecoderElement (
		    (short)0x0002,
		    new QName (
			"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
			"AmbientAirTemperature"
		    )
		),
		new PDUDecoderElement (
		    (short)0x000a,
		    new QName (
			"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
			"WiperSystemFront"
		    )
		),
		new PDUDecoderElement (
		    (short)0x0010,
		    new QName (
			"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
			"DenmPdu"
		    )
		),
		new PDUDecoderElement (
		    (short)0x0016,
		    new QName (
			"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
			"DataReference"
		    )
		)
	    }
	),
	new byte[] {
	    (byte)0x0b, (byte)0x0e, (byte)0xe4, (byte)0x4b, (byte)0x98,
	    (byte)0xce, (byte)0x6d, (byte)0xda, (byte)0x1e, (byte)0xcf,
	    (byte)0x6d, (byte)0xda, (byte)0x1e, (byte)0xde, (byte)0x2f,
	    (byte)0x7a, (byte)0x54, (byte)0x13, (byte)0xb2, (byte)0x2b,
	    (byte)0xb5, (byte)0x94, (byte)0xbc, (byte)0xc8, (byte)0x2d,
	    (byte)0xbf, (byte)0x92, (byte)0x5d, (byte)0xdb, (byte)0x77,
	    (byte)0xd0, (byte)0xd8, (byte)0xa4, (byte)0xb2, (byte)0x5f,
	    (byte)0x81, (byte)0x6a, (byte)0x67, (byte)0xe8, (byte)0xba,
	    (byte)0x33, (byte)0xb7, (byte)0xcb, (byte)0x3d, (byte)0xe7,
	    (byte)0xc3, (byte)0x6f, (byte)0xa2, (byte)0x27, (byte)0x80,
	    (byte)0xf6, (byte)0x6a, (byte)0x68, (byte)0xe5, (byte)0x87,
	    (byte)0x29, (byte)0x84, (byte)0xe3, (byte)0x8c, (byte)0x20,
	    (byte)0xec, (byte)0x98, (byte)0x1c, (byte)0xab, (byte)0x0b,
	    (byte)0x03, (byte)0xef, (byte)0x30, (byte)0x36, (byte)0x0b,
	    (byte)0x05, (byte)0x0e, (byte)0xf9, (byte)0x63, (byte)0xd2,
	    (byte)0xa3, (byte)0x51, (byte)0xb0, (byte)0xa5, (byte)0x6d,
	    (byte)0x29, (byte)0xed, (byte)0x29, (byte)0x57, (byte)0x4c,
	    (byte)0xcd, (byte)0x5b, (byte)0xaf, (byte)0xb9, (byte)0x00,
	    (byte)0xa6, (byte)0xc7, (byte)0xcc, (byte)0xc1, (byte)0x81,
	    (byte)0xdf, (byte)0xb0, (byte)0xe3, (byte)0x21, (byte)0x6f,
	    (byte)0xf3, (byte)0xeb, (byte)0xe8, (byte)0x9a, (byte)0x0e,
	    (byte)0xeb, (byte)0x75, (byte)0x58, (byte)0x84, (byte)0x8e,
	    (byte)0xa1, (byte)0x25, (byte)0x71, (byte)0xf8, (byte)0x01,
	    (byte)0x86
	}
    );
    
    /**
     * Get the project descriptor of 'this' object.
     */
    public ProjectInfo getProjectInfo()
    {
	return c_projectInfo;
    }
    
    private static final ASN1Project c_project = new Libitsdenm_asn1();

    /**
     * Methods for accessing Coders.
     */
    public static Coder getDefaultCoder()
    {
	return createPERAlignedCoder(c_project);
    }
    
    public static PERAlignedCoder getPERAlignedCoder()
    {
	return createPERAlignedCoder(c_project);
    }
    
    public static PERUnalignedCoder getPERUnalignedCoder()
    {
	return createPERUnalignedCoder(c_project);
    }
    
}
