/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm-pdu-descriptions */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Tue Jun 28 12:09:14 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -per -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6535gen/LibItsDenm_asn1.gen DENM-PDU-Descriptions.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.*;

/**
 * Define the ASN1 Type ProfileParameters from ASN1 Module DENM_PDU_Descriptions.
 * @see Choice
 */

public class ProfileParameters extends Choice {
    
    /**
     * The default constructor.
     */
    public ProfileParameters()
    {
    }
    
    public static final  int  basicVehicle_chosen = 1;
    public static final  int  emergencyVehicle_chosen = 2;
    public static final  int  publicTransportVehicle_chosen = 3;
    
    // Methods for field "basicVehicle"
    public static ProfileParameters createProfileParametersWithBasicVehicle(BasicVehicle basicVehicle)
    {
	ProfileParameters __object = new ProfileParameters();

	__object.setBasicVehicle(basicVehicle);
	return __object;
    }
    
    public boolean hasBasicVehicle()
    {
	return getChosenFlag() == basicVehicle_chosen;
    }
    
    public void setBasicVehicle(BasicVehicle basicVehicle)
    {
	setChosenValue(basicVehicle);
	setChosenFlag(basicVehicle_chosen);
    }
    
    
    // Methods for field "emergencyVehicle"
    public static ProfileParameters createProfileParametersWithEmergencyVehicle(EmergencyVehicle emergencyVehicle)
    {
	ProfileParameters __object = new ProfileParameters();

	__object.setEmergencyVehicle(emergencyVehicle);
	return __object;
    }
    
    public boolean hasEmergencyVehicle()
    {
	return getChosenFlag() == emergencyVehicle_chosen;
    }
    
    public void setEmergencyVehicle(EmergencyVehicle emergencyVehicle)
    {
	setChosenValue(emergencyVehicle);
	setChosenFlag(emergencyVehicle_chosen);
    }
    
    
    // Methods for field "publicTransportVehicle"
    public static ProfileParameters createProfileParametersWithPublicTransportVehicle(PublicTransportVehicle publicTransportVehicle)
    {
	ProfileParameters __object = new ProfileParameters();

	__object.setPublicTransportVehicle(publicTransportVehicle);
	return __object;
    }
    
    public boolean hasPublicTransportVehicle()
    {
	return getChosenFlag() == publicTransportVehicle_chosen;
    }
    
    public void setPublicTransportVehicle(PublicTransportVehicle publicTransportVehicle)
    {
	setChosenValue(publicTransportVehicle);
	setChosenFlag(publicTransportVehicle_chosen);
    }
    
    
    // Method to create a specific choice instance
    public AbstractData createInstance(int chosen)
    {
	switch (chosen) {
	    case basicVehicle_chosen:
		return new BasicVehicle();
	    case emergencyVehicle_chosen:
		return new EmergencyVehicle();
	    case publicTransportVehicle_chosen:
		return new PublicTransportVehicle();
	    default:
		throw new InternalError("Choice.createInstance()");
	}
	
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final ChoiceInfo c_typeinfo = new ChoiceInfo (
	new Tags (
	    null
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "ProfileParameters"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "ProfileParameters"
	),
	12318,
	null,
	new Fields (
	    new FieldInfo[] {
		new FieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"BasicVehicle"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"BasicVehicle"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "BasicVehicle"
				)
			    ),
			    0,
			    null,
			    0
			)
		    ),
		    "basicVehicle",
		    0,
		    2
		),
		new FieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"EmergencyVehicle"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"EmergencyVehicle"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "EmergencyVehicle"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "EmergencyVehicle"
				)
			    ),
			    0
			)
		    ),
		    "emergencyVehicle",
		    1,
		    2
		),
		new FieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"PublicTransportVehicle"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"PublicTransportVehicle"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "PublicTransportVehicle"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "PublicTransportVehicle"
				)
			    ),
			    0
			)
		    ),
		    "publicTransportVehicle",
		    2,
		    2
		)
	    }
	),
	0,
	new TagDecoder (
	    new TagDecoderElement[] {
		new TagDecoderElement((short)0x8000, 0),
		new TagDecoderElement((short)0x8001, 1),
		new TagDecoderElement((short)0x8002, 2)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' ProfileParameters object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' ProfileParameters object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Check the current selection on unknown extension
     */
    public final boolean hasUnknownExtension()
    {
	return getChosenFlag() > 3;
    }
    
} // End class definition for ProfileParameters
