/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm-pdu-descriptions */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Tue Jun 28 12:09:14 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -per -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6535gen/LibItsDenm_asn1.gen DENM-PDU-Descriptions.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.*;

/**
 * Define the ASN1 Type Situation from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class Situation extends Sequence {
    
    /**
     * The default constructor.
     */
    public Situation()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public Situation(CauseCode cause, SubCauseCode subCause)
    {
	setCause(cause);
	setSubCause(subCause);
    }
    
    public void initComponents()
    {
	mComponents[0] = new CauseCode();
	mComponents[1] = new SubCauseCode();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[2];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new CauseCode();
	    case 1:
		return new SubCauseCode();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "cause"
    public CauseCode getCause()
    {
	return (CauseCode)mComponents[0];
    }
    
    public void setCause(CauseCode cause)
    {
	mComponents[0] = cause;
    }
    
    
    // Methods for field "subCause"
    public SubCauseCode getSubCause()
    {
	return (SubCauseCode)mComponents[1];
    }
    
    public void setSubCause(SubCauseCode subCause)
    {
	mComponents[1] = subCause;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "Situation"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "Situation"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"CauseCode"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"CauseCode"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new CauseCode(0), 
				    new CauseCode(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"reserved",
					0
				    ),
				    new MemberListElement (
					"dangerousDriving",
					101
				    ),
				    new MemberListElement (
					"intersectionViolation",
					102
				    ),
				    new MemberListElement (
					"vehicleProblem",
					103
				    ),
				    new MemberListElement (
					"intersectionCollision",
					104
				    ),
				    new MemberListElement (
					"hazardousLocation",
					105
				    )
				}
			    )
			)
		    ),
		    "cause",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"SubCauseCode"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"SubCauseCode"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new SubCauseCode(0), 
				    new SubCauseCode(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"unknown",
					0
				    )
				}
			    )
			)
		    ),
		    "subCause",
		    1,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' Situation object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' Situation object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for Situation
