/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm-pdu-descriptions */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Tue Jun 28 12:09:14 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -per -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6535gen/LibItsDenm_asn1.gen DENM-PDU-Descriptions.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.*;

/**
 * Define the ASN1 Type DecentralizedSituationLocation from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class DecentralizedSituationLocation extends Sequence {
    
    /**
     * The default constructor.
     */
    public DecentralizedSituationLocation()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public DecentralizedSituationLocation(_7 eventPosition, _8 locationRef, 
		    RelevanceArea relevanceArea)
    {
	setEventPosition(eventPosition);
	setLocationRef(locationRef);
	setRelevanceArea(relevanceArea);
    }
    
    /**
     * Construct with required components.
     */
    public DecentralizedSituationLocation(_7 eventPosition, _8 locationRef)
    {
	setEventPosition(eventPosition);
	setLocationRef(locationRef);
    }
    
    public void initComponents()
    {
	mComponents[0] = new _7();
	mComponents[1] = new _8();
	mComponents[2] = new RelevanceArea();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[3];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new _7();
	    case 1:
		return new _8();
	    case 2:
		return new RelevanceArea();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "eventPosition"
    public _7 getEventPosition()
    {
	return (_7)mComponents[0];
    }
    
    public void setEventPosition(_7 eventPosition)
    {
	mComponents[0] = eventPosition;
    }
    
    
    
    /**
     * Define the ASN1 Type _7 from ASN1 Module DENM_PDU_Descriptions.
     * @see Choice
     */
    public static class _7 extends Choice {
	
	/**
	 * The default constructor.
	 */
	public _7()
	{
	}
	
	public static final  int  eventPositionCurrentDefinition_chosen = 1;
	
	// Methods for field "eventPositionCurrentDefinition"
	public static _7 create_7WithEventPositionCurrentDefinition(EventPosition eventPositionCurrentDefinition)
	{
	    _7 __object = new _7();

	    __object.setEventPositionCurrentDefinition(eventPositionCurrentDefinition);
	    return __object;
	}
	
	public boolean hasEventPositionCurrentDefinition()
	{
	    return getChosenFlag() == eventPositionCurrentDefinition_chosen;
	}
	
	public void setEventPositionCurrentDefinition(EventPosition eventPositionCurrentDefinition)
	{
	    setChosenValue(eventPositionCurrentDefinition);
	    setChosenFlag(eventPositionCurrentDefinition_chosen);
	}
	
	
	// Method to create a specific choice instance
	public AbstractData createInstance(int chosen)
	{
	    switch (chosen) {
		case eventPositionCurrentDefinition_chosen:
		    return new EventPosition();
		default:
		    throw new InternalError("Choice.createInstance()");
	    }
	    
	}
	
	/**
	 * Initialize the type descriptor.
	 */
	private static final ChoiceInfo c_typeinfo = new ChoiceInfo (
	    new Tags (
		new short[] {
		    (short)0x8000
		}
	    ),
	    new QName (
		"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
		"DecentralizedSituationLocation$_7"
	    ),
	    new QName (
		"builtin",
		"CHOICE"
	    ),
	    12318,
	    null,
	    new Fields (
		new FieldInfo[] {
		    new FieldInfo (
			new TypeInfoRef (
			    new SequenceInfo (
				new Tags (
				    new short[] {
					(short)0x8000
				    }
				),
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "EventPosition"
				),
				new QName (
				    "DENM-PDU-Descriptions",
				    "EventPosition"
				),
				12314,
				null,
				new FieldsRef (
				    new QName (
					"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
					"EventPosition"
				    )
				),
				0,
				new TagDecodersRef (
				    new QName (
					"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
					"EventPosition"
				    )
				),
				0
			    )
			),
			"eventPositionCurrentDefinition",
			0,
			2
		    )
		}
	    ),
	    0,
	    new TagDecoder (
		new TagDecoderElement[] {
		    new TagDecoderElement((short)0x8000, 0)
		}
	    )
	);
	
	/**
	 * Get the type descriptor (TypeInfo) of 'this' _7 object.
	 */
	public TypeInfo getTypeInfo()
	{
	    return c_typeinfo;
	}
	
	/**
	 * Get the static type descriptor (TypeInfo) of 'this' _7 object.
	 */
	public static TypeInfo getStaticTypeInfo()
	{
	    return c_typeinfo;
	}
	
	/**
	 * Check the current selection on unknown extension
	 */
	public final boolean hasUnknownExtension()
	{
	    return getChosenFlag() > 1;
	}
	
    } // End class definition for _7

    // Methods for field "locationRef"
    public _8 getLocationRef()
    {
	return (_8)mComponents[1];
    }
    
    public void setLocationRef(_8 locationRef)
    {
	mComponents[1] = locationRef;
    }
    
    
    
    /**
     * Define the ASN1 Type _8 from ASN1 Module DENM_PDU_Descriptions.
     * @see Choice
     */
    public static class _8 extends Choice {
	
	/**
	 * The default constructor.
	 */
	public _8()
	{
	}
	
	public static final  int  trace_chosen = 1;
	
	// Methods for field "trace"
	public static _8 create_8WithTrace(TraceLocData trace)
	{
	    _8 __object = new _8();

	    __object.setTrace(trace);
	    return __object;
	}
	
	public boolean hasTrace()
	{
	    return getChosenFlag() == trace_chosen;
	}
	
	public void setTrace(TraceLocData trace)
	{
	    setChosenValue(trace);
	    setChosenFlag(trace_chosen);
	}
	
	
	// Method to create a specific choice instance
	public AbstractData createInstance(int chosen)
	{
	    switch (chosen) {
		case trace_chosen:
		    return new TraceLocData();
		default:
		    throw new InternalError("Choice.createInstance()");
	    }
	    
	}
	
	/**
	 * Initialize the type descriptor.
	 */
	private static final ChoiceInfo c_typeinfo = new ChoiceInfo (
	    new Tags (
		new short[] {
		    (short)0x8001
		}
	    ),
	    new QName (
		"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
		"DecentralizedSituationLocation$_8"
	    ),
	    new QName (
		"builtin",
		"CHOICE"
	    ),
	    12318,
	    null,
	    new Fields (
		new FieldInfo[] {
		    new FieldInfo (
			new TypeInfoRef (
			    new SequenceInfo (
				new Tags (
				    new short[] {
					(short)0x8000
				    }
				),
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "TraceLocData"
				),
				new QName (
				    "DENM-PDU-Descriptions",
				    "TraceLocData"
				),
				12314,
				null,
				new FieldsRef (
				    new QName (
					"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
					"TraceLocData"
				    )
				),
				0,
				new TagDecodersRef (
				    new QName (
					"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
					"TraceLocData"
				    )
				),
				0
			    )
			),
			"trace",
			0,
			2
		    )
		}
	    ),
	    0,
	    new TagDecoder (
		new TagDecoderElement[] {
		    new TagDecoderElement((short)0x8000, 0)
		}
	    )
	);
	
	/**
	 * Get the type descriptor (TypeInfo) of 'this' _8 object.
	 */
	public TypeInfo getTypeInfo()
	{
	    return c_typeinfo;
	}
	
	/**
	 * Get the static type descriptor (TypeInfo) of 'this' _8 object.
	 */
	public static TypeInfo getStaticTypeInfo()
	{
	    return c_typeinfo;
	}
	
	/**
	 * Check the current selection on unknown extension
	 */
	public final boolean hasUnknownExtension()
	{
	    return getChosenFlag() > 1;
	}
	
    } // End class definition for _8

    // Methods for field "relevanceArea"
    public RelevanceArea getRelevanceArea()
    {
	return (RelevanceArea)mComponents[2];
    }
    
    public void setRelevanceArea(RelevanceArea relevanceArea)
    {
	mComponents[2] = relevanceArea;
    }
    
    public boolean hasRelevanceArea()
    {
	return componentIsPresent(2);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "DecentralizedSituationLocation"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "DecentralizedSituationLocation"
	),
	12318,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new QName (
			    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
			    "DecentralizedSituationLocation$_7"
			)
		    ),
		    "eventPosition",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new QName (
			    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
			    "DecentralizedSituationLocation$_8"
			)
		    ),
		    "locationRef",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"RelevanceArea"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"RelevanceArea"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "RelevanceArea"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "RelevanceArea"
				)
			    ),
			    0
			)
		    ),
		    "relevanceArea",
		    2,
		    130,
		    null
		)
	    }
	),
	1,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' DecentralizedSituationLocation object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' DecentralizedSituationLocation object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for DecentralizedSituationLocation
